/*
 * Copyright (c) 2013, Linz Center of Mechatronics GmbH (LCM), web: www.lcm.at
 * All rights reserved.
 */
/*
 * This file is licensed according to the BSD 3-clause license as follows:
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the "Linz Center of Mechatronics GmbH" and "LCM" nor
 *       the names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL "Linz Center of Mechatronics GmbH" BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/*
 * This file is part of X2C. web: x2c.lcm.at
 * $LastChangedRevision: 4457 $
 * $LastChangedDate:: 2026-08-13 18:59:23 +0200#$
 */
/* USERCODE-BEGIN:Description */
/* Description: */
/* USERCODE-END:Description */

package at.lcm.x2c.library.general;

import at.lcm.x2c.core.structure.*;
import at.lcm.bu21.general.dtypes.*;

/* USERCODE-BEGIN:Imports */
import at.lcm.x2c.utils.QFormat;
/* USERCODE-END:Imports */

@SuppressWarnings("unused")
public class ConvFnc_LookupTable3D_FiP32 extends JavaConversionFunction {
    private static final long serialVersionUID = 1L;

    @Override
    public void convertMaskToImplementation() throws Exception {
        MaskDouble TableDataMaskVal = (MaskDouble)this.getMaskParameter("TableData").getMaskDataType();
        TNumeric TableDataMaskData = (TNumeric)TableDataMaskVal.getData();
        double mp_TableData = TableDataMaskData.getReal(0, 0);
        MaskComboBox DimXMaskVal = (MaskComboBox)this.getMaskParameter("DimX").getMaskDataType();
        TString DimXMaskData = (TString)DimXMaskVal.getData();
        String mp_DimX = DimXMaskData.getString();
        MaskDouble x_minMaskVal = (MaskDouble)this.getMaskParameter("x_min").getMaskDataType();
        TNumeric x_minMaskData = (TNumeric)x_minMaskVal.getData();
        double mp_x_min = x_minMaskData.getReal(0, 0);
        MaskDouble x_maxMaskVal = (MaskDouble)this.getMaskParameter("x_max").getMaskDataType();
        TNumeric x_maxMaskData = (TNumeric)x_maxMaskVal.getData();
        double mp_x_max = x_maxMaskData.getReal(0, 0);
        MaskComboBox DimYMaskVal = (MaskComboBox)this.getMaskParameter("DimY").getMaskDataType();
        TString DimYMaskData = (TString)DimYMaskVal.getData();
        String mp_DimY = DimYMaskData.getString();
        MaskDouble y_maxMaskVal = (MaskDouble)this.getMaskParameter("y_max").getMaskDataType();
        TNumeric y_maxMaskData = (TNumeric)y_maxMaskVal.getData();
        double mp_y_max = y_maxMaskData.getReal(0, 0);
        MaskDouble y_minMaskVal = (MaskDouble)this.getMaskParameter("y_min").getMaskDataType();
        TNumeric y_minMaskData = (TNumeric)y_minMaskVal.getData();
        double mp_y_min = y_minMaskData.getReal(0, 0);
        MaskComboBox DimZMaskVal = (MaskComboBox)this.getMaskParameter("DimZ").getMaskDataType();
        TString DimZMaskData = (TString)DimZMaskVal.getData();
        String mp_DimZ = DimZMaskData.getString();
        MaskDouble z_minMaskVal = (MaskDouble)this.getMaskParameter("z_min").getMaskDataType();
        TNumeric z_minMaskData = (TNumeric)z_minMaskVal.getData();
        double mp_z_min = z_minMaskData.getReal(0, 0);
        MaskDouble z_maxMaskVal = (MaskDouble)this.getMaskParameter("z_max").getMaskDataType();
        TNumeric z_maxMaskData = (TNumeric)z_maxMaskVal.getData();
        double mp_z_max = z_maxMaskData.getReal(0, 0);

        TNumeric TableCtrVal = this.getImplementationParameterData("Table");
        double[] cp_Table = null;
        TNumeric sfrXCtrVal = this.getImplementationParameterData("sfrX");
        double cp_sfrX = Double.NaN;
        TNumeric sfrYCtrVal = this.getImplementationParameterData("sfrY");
        double cp_sfrY = Double.NaN;
        TNumeric sfrZCtrVal = this.getImplementationParameterData("sfrZ");
        double cp_sfrZ = Double.NaN;
        TNumeric maskXCtrVal = this.getImplementationParameterData("maskX");
        double cp_maskX = Double.NaN;
        TNumeric maskYCtrVal = this.getImplementationParameterData("maskY");
        double cp_maskY = Double.NaN;
        TNumeric maskZCtrVal = this.getImplementationParameterData("maskZ");
        double cp_maskZ = Double.NaN;
        TNumeric idxOffsetXCtrVal = this.getImplementationParameterData("idxOffsetX");
        double cp_idxOffsetX = Double.NaN;
        TNumeric idxOffsetYCtrVal = this.getImplementationParameterData("idxOffsetY");
        double cp_idxOffsetY = Double.NaN;
        TNumeric idxOffsetZCtrVal = this.getImplementationParameterData("idxOffsetZ");
        double cp_idxOffsetZ = Double.NaN;
        TNumeric sizeXCtrVal = this.getImplementationParameterData("sizeX");
        double cp_sizeX = Double.NaN;
        TNumeric sizeYCtrVal = this.getImplementationParameterData("sizeY");
        double cp_sizeY = Double.NaN;
        TNumeric sizeXYCtrVal = this.getImplementationParameterData("sizeXY");
        double cp_sizeXY = Double.NaN;
        TNumeric gainXCtrVal = this.getImplementationParameterData("gainX");
        double cp_gainX = Double.NaN;
        TNumeric gainYCtrVal = this.getImplementationParameterData("gainY");
        double cp_gainY = Double.NaN;
        TNumeric gainZCtrVal = this.getImplementationParameterData("gainZ");
        double cp_gainZ = Double.NaN;
        TNumeric gainXsfrCtrVal = this.getImplementationParameterData("gainXsfr");
        double cp_gainXsfr = Double.NaN;
        TNumeric gainYsfrCtrVal = this.getImplementationParameterData("gainYsfr");
        double cp_gainYsfr = Double.NaN;
        TNumeric gainZsfrCtrVal = this.getImplementationParameterData("gainZsfr");
        double cp_gainZsfr = Double.NaN;
        TNumeric offsetXCtrVal = this.getImplementationParameterData("offsetX");
        double cp_offsetX = Double.NaN;
        TNumeric offsetYCtrVal = this.getImplementationParameterData("offsetY");
        double cp_offsetY = Double.NaN;
        TNumeric offsetZCtrVal = this.getImplementationParameterData("offsetZ");
        double cp_offsetZ = Double.NaN;
        TNumeric minXCtrVal = this.getImplementationParameterData("minX");
        double cp_minX = Double.NaN;
        TNumeric maxXCtrVal = this.getImplementationParameterData("maxX");
        double cp_maxX = Double.NaN;
        TNumeric minYCtrVal = this.getImplementationParameterData("minY");
        double cp_minY = Double.NaN;
        TNumeric maxYCtrVal = this.getImplementationParameterData("maxY");
        double cp_maxY = Double.NaN;
        TNumeric minZCtrVal = this.getImplementationParameterData("minZ");
        double cp_minZ = Double.NaN;
        TNumeric maxZCtrVal = this.getImplementationParameterData("maxZ");
        double cp_maxZ = Double.NaN;

        /* ATTENTION: */
        /* The M2I conversion function may either use the mp_* or *MaskVal value to get the Mask Parameter value */
        /* For new or updated implementations, the mp_* value shall be used where possible */
        /* Currently, the mp_* value cannot be used for getting non-scalar Mask Parameter data but will return only the first element for these */
        /* The Implementation Parameter assignment variables cp_* can and shall be used for all Implementation Parameter data types */

        /* INFO: Implementation data assignment for array types when using the cp_* variables */
        /* If the cp_* parameter is a FLASH ARRAY, the cp_* variable is assigned an array type but without an actual array */
        /* The M2I conversion function has to assign an array with the correct size and fill it with content */
        /* If the cp_* parameter is a RAM ARRAY, the cp_* variable is assigned an array with the correct size */
        /* The first element is assigned an invalid value while the other elements are (auto)initialized with zero */
        /* The M2I conversion function has to fill the array with content */

        /* Mask parameter values */
        /* mp_TableData OR TableDataMaskVal (Number) */
        /* mp_DimX OR DimXMaskVal (String) */
        /* mp_x_min OR x_minMaskVal (Number) */
        /* mp_x_max OR x_maxMaskVal (Number) */
        /* mp_DimY OR DimYMaskVal (String) */
        /* mp_y_max OR y_maxMaskVal (Number) */
        /* mp_y_min OR y_minMaskVal (Number) */
        /* mp_DimZ OR DimZMaskVal (String) */
        /* mp_z_min OR z_minMaskVal (Number) */
        /* mp_z_max OR z_maxMaskVal (Number) */

        /* USERCODE-BEGIN:ConvMaskToImplementation */
        int size_x;
        int size_y;
        int size_z;
        final int SIZE_ROW = 1;
        final int BITS = 32;
        double sfrX, sfrY, sfrZ;
        double x_min, x_max, offsetX, gainX, y_min, y_max, offsetY, gainY, z_min, z_max, offsetZ, gainZ;

        /* get table size */
        size_x = Integer.valueOf(DimXMaskVal.getValue());
        size_y = Integer.valueOf(DimYMaskVal.getValue());
        size_z = Integer.valueOf(DimZMaskVal.getValue());

        /* check table data for correct size */
        if ((TableDataMaskData.getNumColumns() != (size_x * size_y * size_z)) || (TableDataMaskData.getNumRows() != SIZE_ROW)) {
            throw new Exception("Lookup Table Size mismatch in column: expected=(" + SIZE_ROW + ", " + (size_x * size_y * size_z) + ") " + "got=("
                    + TableDataMaskData.getNumRows() + "," + TableDataMaskData.getNumColumns() + ")");
        }

        /* convert dimension value */
        sizeXCtrVal.setReal(0, 0, size_x);
        sizeYCtrVal.setReal(0, 0, size_y);
        sizeXYCtrVal.setReal(0, 0, size_x * size_y);

        /* convert input scaling */
        x_min = Double.valueOf(x_minMaskVal.getValue());
        x_max = Double.valueOf(x_maxMaskVal.getValue());
        if (x_min >= x_max) {
            throw new Exception("Scaling of x-dimension not possible: x_max must be greater than x_min!)");
        }
        offsetX = x_min + ((x_max - x_min) / 2);
        gainX = 2 / (x_max - x_min);
        offsetXCtrVal.setReal(0, 0, Double.valueOf(QFormat.getQValue(offsetX, BITS - 1, BITS, true)));
        gainXsfrCtrVal.setReal(0, 0, Double.valueOf(QFormat.getQFormat(gainX, BITS, true)));
        gainXCtrVal.setReal(0, 0, Double.valueOf(QFormat.getQValue(gainX, (int) (gainXsfrCtrVal.getReal(0, 0)), BITS, true)));

        y_min = Double.valueOf(y_minMaskVal.getValue());
        y_max = Double.valueOf(y_maxMaskVal.getValue());
        if (y_min >= y_max) {
            throw new Exception("Scaling of y-dimension not possible: y_max must be greater than y_min!)");
        }
        offsetY = y_min + ((y_max - y_min) / 2);
        gainY = 2 / (y_max - y_min);
        offsetYCtrVal.setReal(0, 0, Double.valueOf(QFormat.getQValue(offsetY, BITS - 1, BITS, true)));
        gainYsfrCtrVal.setReal(0, 0, Double.valueOf(QFormat.getQFormat(gainY, BITS, true)));
        gainYCtrVal.setReal(0, 0, Double.valueOf(QFormat.getQValue(gainY, (int) (gainYsfrCtrVal.getReal(0, 0)), BITS, true)));

        z_min = Double.valueOf(z_minMaskVal.getValue());
        z_max = Double.valueOf(z_maxMaskVal.getValue());
        if (z_min >= z_max) {
            throw new Exception("Scaling of z-dimension not possible: z_max must be greater than z_min!)");
        }
        offsetZ = z_min + ((z_max - z_min) / 2);
        gainZ = 2 / (z_max - z_min);
        offsetZCtrVal.setReal(0, 0, Double.valueOf(QFormat.getQValue(offsetZ, BITS - 1, BITS, true)));
        gainZsfrCtrVal.setReal(0, 0, Double.valueOf(QFormat.getQFormat(gainZ, BITS, true)));
        gainZCtrVal.setReal(0, 0, Double.valueOf(QFormat.getQValue(gainZ, (int) (gainZsfrCtrVal.getReal(0, 0)), BITS, true)));

        /* convert boundaries */
        minXCtrVal.setReal(0, 0, Double.valueOf(QFormat.getQValue(x_min, BITS - 1, BITS, true)));
        maxXCtrVal.setReal(0, 0, Double.valueOf(QFormat.getQValue(x_max, BITS - 1, BITS, true)));

        minYCtrVal.setReal(0, 0, Double.valueOf(QFormat.getQValue(y_min, BITS - 1, BITS, true)));
        maxYCtrVal.setReal(0, 0, Double.valueOf(QFormat.getQValue(y_max, BITS - 1, BITS, true)));

        minZCtrVal.setReal(0, 0, Double.valueOf(QFormat.getQValue(z_min, BITS - 1, BITS, true)));
        maxZCtrVal.setReal(0, 0, Double.valueOf(QFormat.getQValue(z_max, BITS - 1, BITS, true)));

        /* convert FiP scaling */
        sfrX = Double.valueOf(QFormat.getQFormat(size_x - 1, BITS + 2, true));
        sfrXCtrVal.setReal(0, 0, sfrX);
        maskXCtrVal.setReal(0, 0, Math.pow(2, sfrX) - 1);
        idxOffsetXCtrVal.setReal(0, 0, Math.pow(2, BITS - 1 - sfrX));

        sfrY = Double.valueOf(QFormat.getQFormat(size_y - 1, BITS + 2, true));
        sfrYCtrVal.setReal(0, 0, sfrY);
        maskYCtrVal.setReal(0, 0, Math.pow(2, sfrY) - 1);
        idxOffsetYCtrVal.setReal(0, 0, Math.pow(2, BITS - 1 - sfrY));

        sfrZ = Double.valueOf(QFormat.getQFormat(size_z - 1, BITS + 2, true));
        sfrZCtrVal.setReal(0, 0, sfrZ);
        maskZCtrVal.setReal(0, 0, Math.pow(2, sfrZ) - 1);
        idxOffsetZCtrVal.setReal(0, 0, Math.pow(2, BITS - 1 - sfrZ));

        /* convert table data */
        Double[] tmpData = new Double[size_x * size_y * size_z];
        for (int z = 0; z < size_z; z++) {
            for (int y = 0; y < size_y; y++) {
                for (int x = 0; x < size_x; x++) {
                    tmpData[x + (size_x * y) + (size_x * size_y * z)] = Double.valueOf(QFormat.getQValue(
                            TableDataMaskData.getReal(0, x + (size_x * y) + (size_x * size_y * z)), BITS - 1, BITS, true));
                }
            }
        }

        TableCtrVal = new TNumeric(tmpData);

        /* USERCODE-END:ConvMaskToImplementation */

        /* Implementation Parameter values */
        /* cp_Table OR TableCtrVal (Flash array) */
        /* cp_sfrX OR sfrXCtrVal (Value) */
        /* cp_sfrY OR sfrYCtrVal (Value) */
        /* cp_sfrZ OR sfrZCtrVal (Value) */
        /* cp_maskX OR maskXCtrVal (Value) */
        /* cp_maskY OR maskYCtrVal (Value) */
        /* cp_maskZ OR maskZCtrVal (Value) */
        /* cp_idxOffsetX OR idxOffsetXCtrVal (Value) */
        /* cp_idxOffsetY OR idxOffsetYCtrVal (Value) */
        /* cp_idxOffsetZ OR idxOffsetZCtrVal (Value) */
        /* cp_sizeX OR sizeXCtrVal (Value) */
        /* cp_sizeY OR sizeYCtrVal (Value) */
        /* cp_sizeXY OR sizeXYCtrVal (Value) */
        /* cp_gainX OR gainXCtrVal (Value) */
        /* cp_gainY OR gainYCtrVal (Value) */
        /* cp_gainZ OR gainZCtrVal (Value) */
        /* cp_gainXsfr OR gainXsfrCtrVal (Value) */
        /* cp_gainYsfr OR gainYsfrCtrVal (Value) */
        /* cp_gainZsfr OR gainZsfrCtrVal (Value) */
        /* cp_offsetX OR offsetXCtrVal (Value) */
        /* cp_offsetY OR offsetYCtrVal (Value) */
        /* cp_offsetZ OR offsetZCtrVal (Value) */
        /* cp_minX OR minXCtrVal (Value) */
        /* cp_maxX OR maxXCtrVal (Value) */
        /* cp_minY OR minYCtrVal (Value) */
        /* cp_maxY OR maxYCtrVal (Value) */
        /* cp_minZ OR minZCtrVal (Value) */
        /* cp_maxZ OR maxZCtrVal (Value) */

        if (cp_Table == null) {
            this.setImplementationParameterData("Table", TableCtrVal);
        } else {
            this.setImplementationParameterData("Table", new TNumeric(cp_Table));
        }
        if (Double.isNaN(cp_sfrX)) {
            this.setImplementationParameterData("sfrX", sfrXCtrVal);
        } else {
            this.setImplementationParameterData("sfrX", new TNumeric(cp_sfrX));
        }
        if (Double.isNaN(cp_sfrY)) {
            this.setImplementationParameterData("sfrY", sfrYCtrVal);
        } else {
            this.setImplementationParameterData("sfrY", new TNumeric(cp_sfrY));
        }
        if (Double.isNaN(cp_sfrZ)) {
            this.setImplementationParameterData("sfrZ", sfrZCtrVal);
        } else {
            this.setImplementationParameterData("sfrZ", new TNumeric(cp_sfrZ));
        }
        if (Double.isNaN(cp_maskX)) {
            this.setImplementationParameterData("maskX", maskXCtrVal);
        } else {
            this.setImplementationParameterData("maskX", new TNumeric(cp_maskX));
        }
        if (Double.isNaN(cp_maskY)) {
            this.setImplementationParameterData("maskY", maskYCtrVal);
        } else {
            this.setImplementationParameterData("maskY", new TNumeric(cp_maskY));
        }
        if (Double.isNaN(cp_maskZ)) {
            this.setImplementationParameterData("maskZ", maskZCtrVal);
        } else {
            this.setImplementationParameterData("maskZ", new TNumeric(cp_maskZ));
        }
        if (Double.isNaN(cp_idxOffsetX)) {
            this.setImplementationParameterData("idxOffsetX", idxOffsetXCtrVal);
        } else {
            this.setImplementationParameterData("idxOffsetX", new TNumeric(cp_idxOffsetX));
        }
        if (Double.isNaN(cp_idxOffsetY)) {
            this.setImplementationParameterData("idxOffsetY", idxOffsetYCtrVal);
        } else {
            this.setImplementationParameterData("idxOffsetY", new TNumeric(cp_idxOffsetY));
        }
        if (Double.isNaN(cp_idxOffsetZ)) {
            this.setImplementationParameterData("idxOffsetZ", idxOffsetZCtrVal);
        } else {
            this.setImplementationParameterData("idxOffsetZ", new TNumeric(cp_idxOffsetZ));
        }
        if (Double.isNaN(cp_sizeX)) {
            this.setImplementationParameterData("sizeX", sizeXCtrVal);
        } else {
            this.setImplementationParameterData("sizeX", new TNumeric(cp_sizeX));
        }
        if (Double.isNaN(cp_sizeY)) {
            this.setImplementationParameterData("sizeY", sizeYCtrVal);
        } else {
            this.setImplementationParameterData("sizeY", new TNumeric(cp_sizeY));
        }
        if (Double.isNaN(cp_sizeXY)) {
            this.setImplementationParameterData("sizeXY", sizeXYCtrVal);
        } else {
            this.setImplementationParameterData("sizeXY", new TNumeric(cp_sizeXY));
        }
        if (Double.isNaN(cp_gainX)) {
            this.setImplementationParameterData("gainX", gainXCtrVal);
        } else {
            this.setImplementationParameterData("gainX", new TNumeric(cp_gainX));
        }
        if (Double.isNaN(cp_gainY)) {
            this.setImplementationParameterData("gainY", gainYCtrVal);
        } else {
            this.setImplementationParameterData("gainY", new TNumeric(cp_gainY));
        }
        if (Double.isNaN(cp_gainZ)) {
            this.setImplementationParameterData("gainZ", gainZCtrVal);
        } else {
            this.setImplementationParameterData("gainZ", new TNumeric(cp_gainZ));
        }
        if (Double.isNaN(cp_gainXsfr)) {
            this.setImplementationParameterData("gainXsfr", gainXsfrCtrVal);
        } else {
            this.setImplementationParameterData("gainXsfr", new TNumeric(cp_gainXsfr));
        }
        if (Double.isNaN(cp_gainYsfr)) {
            this.setImplementationParameterData("gainYsfr", gainYsfrCtrVal);
        } else {
            this.setImplementationParameterData("gainYsfr", new TNumeric(cp_gainYsfr));
        }
        if (Double.isNaN(cp_gainZsfr)) {
            this.setImplementationParameterData("gainZsfr", gainZsfrCtrVal);
        } else {
            this.setImplementationParameterData("gainZsfr", new TNumeric(cp_gainZsfr));
        }
        if (Double.isNaN(cp_offsetX)) {
            this.setImplementationParameterData("offsetX", offsetXCtrVal);
        } else {
            this.setImplementationParameterData("offsetX", new TNumeric(cp_offsetX));
        }
        if (Double.isNaN(cp_offsetY)) {
            this.setImplementationParameterData("offsetY", offsetYCtrVal);
        } else {
            this.setImplementationParameterData("offsetY", new TNumeric(cp_offsetY));
        }
        if (Double.isNaN(cp_offsetZ)) {
            this.setImplementationParameterData("offsetZ", offsetZCtrVal);
        } else {
            this.setImplementationParameterData("offsetZ", new TNumeric(cp_offsetZ));
        }
        if (Double.isNaN(cp_minX)) {
            this.setImplementationParameterData("minX", minXCtrVal);
        } else {
            this.setImplementationParameterData("minX", new TNumeric(cp_minX));
        }
        if (Double.isNaN(cp_maxX)) {
            this.setImplementationParameterData("maxX", maxXCtrVal);
        } else {
            this.setImplementationParameterData("maxX", new TNumeric(cp_maxX));
        }
        if (Double.isNaN(cp_minY)) {
            this.setImplementationParameterData("minY", minYCtrVal);
        } else {
            this.setImplementationParameterData("minY", new TNumeric(cp_minY));
        }
        if (Double.isNaN(cp_maxY)) {
            this.setImplementationParameterData("maxY", maxYCtrVal);
        } else {
            this.setImplementationParameterData("maxY", new TNumeric(cp_maxY));
        }
        if (Double.isNaN(cp_minZ)) {
            this.setImplementationParameterData("minZ", minZCtrVal);
        } else {
            this.setImplementationParameterData("minZ", new TNumeric(cp_minZ));
        }
        if (Double.isNaN(cp_maxZ)) {
            this.setImplementationParameterData("maxZ", maxZCtrVal);
        } else {
            this.setImplementationParameterData("maxZ", new TNumeric(cp_maxZ));
        }
    }

    @Override
    public void convertImplementationToMask() throws Exception {
        MaskDouble TableDataMaskVal = (MaskDouble)this.getMaskParameter("TableData").getMaskDataType();
        TNumeric TableDataMaskData = (TNumeric)TableDataMaskVal.getData();
        double mp_TableData = Double.NaN;
        MaskComboBox DimXMaskVal = (MaskComboBox)this.getMaskParameter("DimX").getMaskDataType();
        TString DimXMaskData = (TString)DimXMaskVal.getData();
        String mp_DimX = null;
        MaskDouble x_minMaskVal = (MaskDouble)this.getMaskParameter("x_min").getMaskDataType();
        TNumeric x_minMaskData = (TNumeric)x_minMaskVal.getData();
        double mp_x_min = Double.NaN;
        MaskDouble x_maxMaskVal = (MaskDouble)this.getMaskParameter("x_max").getMaskDataType();
        TNumeric x_maxMaskData = (TNumeric)x_maxMaskVal.getData();
        double mp_x_max = Double.NaN;
        MaskComboBox DimYMaskVal = (MaskComboBox)this.getMaskParameter("DimY").getMaskDataType();
        TString DimYMaskData = (TString)DimYMaskVal.getData();
        String mp_DimY = null;
        MaskDouble y_maxMaskVal = (MaskDouble)this.getMaskParameter("y_max").getMaskDataType();
        TNumeric y_maxMaskData = (TNumeric)y_maxMaskVal.getData();
        double mp_y_max = Double.NaN;
        MaskDouble y_minMaskVal = (MaskDouble)this.getMaskParameter("y_min").getMaskDataType();
        TNumeric y_minMaskData = (TNumeric)y_minMaskVal.getData();
        double mp_y_min = Double.NaN;
        MaskComboBox DimZMaskVal = (MaskComboBox)this.getMaskParameter("DimZ").getMaskDataType();
        TString DimZMaskData = (TString)DimZMaskVal.getData();
        String mp_DimZ = null;
        MaskDouble z_minMaskVal = (MaskDouble)this.getMaskParameter("z_min").getMaskDataType();
        TNumeric z_minMaskData = (TNumeric)z_minMaskVal.getData();
        double mp_z_min = Double.NaN;
        MaskDouble z_maxMaskVal = (MaskDouble)this.getMaskParameter("z_max").getMaskDataType();
        TNumeric z_maxMaskData = (TNumeric)z_maxMaskVal.getData();
        double mp_z_max = Double.NaN;

        TNumeric sfrXCtrVal = this.getImplementationParameterData("sfrX");
        double cp_sfrX = sfrXCtrVal.getReal(0, 0);
        TNumeric sfrYCtrVal = this.getImplementationParameterData("sfrY");
        double cp_sfrY = sfrYCtrVal.getReal(0, 0);
        TNumeric sfrZCtrVal = this.getImplementationParameterData("sfrZ");
        double cp_sfrZ = sfrZCtrVal.getReal(0, 0);
        TNumeric maskXCtrVal = this.getImplementationParameterData("maskX");
        double cp_maskX = maskXCtrVal.getReal(0, 0);
        TNumeric maskYCtrVal = this.getImplementationParameterData("maskY");
        double cp_maskY = maskYCtrVal.getReal(0, 0);
        TNumeric maskZCtrVal = this.getImplementationParameterData("maskZ");
        double cp_maskZ = maskZCtrVal.getReal(0, 0);
        TNumeric idxOffsetXCtrVal = this.getImplementationParameterData("idxOffsetX");
        double cp_idxOffsetX = idxOffsetXCtrVal.getReal(0, 0);
        TNumeric idxOffsetYCtrVal = this.getImplementationParameterData("idxOffsetY");
        double cp_idxOffsetY = idxOffsetYCtrVal.getReal(0, 0);
        TNumeric idxOffsetZCtrVal = this.getImplementationParameterData("idxOffsetZ");
        double cp_idxOffsetZ = idxOffsetZCtrVal.getReal(0, 0);
        TNumeric sizeXCtrVal = this.getImplementationParameterData("sizeX");
        double cp_sizeX = sizeXCtrVal.getReal(0, 0);
        TNumeric sizeYCtrVal = this.getImplementationParameterData("sizeY");
        double cp_sizeY = sizeYCtrVal.getReal(0, 0);
        TNumeric sizeXYCtrVal = this.getImplementationParameterData("sizeXY");
        double cp_sizeXY = sizeXYCtrVal.getReal(0, 0);
        TNumeric gainXCtrVal = this.getImplementationParameterData("gainX");
        double cp_gainX = gainXCtrVal.getReal(0, 0);
        TNumeric gainYCtrVal = this.getImplementationParameterData("gainY");
        double cp_gainY = gainYCtrVal.getReal(0, 0);
        TNumeric gainZCtrVal = this.getImplementationParameterData("gainZ");
        double cp_gainZ = gainZCtrVal.getReal(0, 0);
        TNumeric gainXsfrCtrVal = this.getImplementationParameterData("gainXsfr");
        double cp_gainXsfr = gainXsfrCtrVal.getReal(0, 0);
        TNumeric gainYsfrCtrVal = this.getImplementationParameterData("gainYsfr");
        double cp_gainYsfr = gainYsfrCtrVal.getReal(0, 0);
        TNumeric gainZsfrCtrVal = this.getImplementationParameterData("gainZsfr");
        double cp_gainZsfr = gainZsfrCtrVal.getReal(0, 0);
        TNumeric offsetXCtrVal = this.getImplementationParameterData("offsetX");
        double cp_offsetX = offsetXCtrVal.getReal(0, 0);
        TNumeric offsetYCtrVal = this.getImplementationParameterData("offsetY");
        double cp_offsetY = offsetYCtrVal.getReal(0, 0);
        TNumeric offsetZCtrVal = this.getImplementationParameterData("offsetZ");
        double cp_offsetZ = offsetZCtrVal.getReal(0, 0);
        TNumeric minXCtrVal = this.getImplementationParameterData("minX");
        double cp_minX = minXCtrVal.getReal(0, 0);
        TNumeric maxXCtrVal = this.getImplementationParameterData("maxX");
        double cp_maxX = maxXCtrVal.getReal(0, 0);
        TNumeric minYCtrVal = this.getImplementationParameterData("minY");
        double cp_minY = minYCtrVal.getReal(0, 0);
        TNumeric maxYCtrVal = this.getImplementationParameterData("maxY");
        double cp_maxY = maxYCtrVal.getReal(0, 0);
        TNumeric minZCtrVal = this.getImplementationParameterData("minZ");
        double cp_minZ = minZCtrVal.getReal(0, 0);
        TNumeric maxZCtrVal = this.getImplementationParameterData("maxZ");
        double cp_maxZ = maxZCtrVal.getReal(0, 0);

        /* ATTENTION: */
        /* The I2M conversion function may either use the cp_* or *CtrlVal value to get the Implementation Parameter value */
        /* For new or updated implementations, the cp_* value shall be used for all Implementation Parameter data types */
        /* The Mask Parameter assignment variables cp_* shall be used where possible */
        /* Currently, the mp_* variable assignment value cannot be used for setting non-scalar Mask Parameter data */

        /* Implementation Parameter values */
        /* cp_sfrX OR sfrXCtrVal (Value) */
        /* cp_sfrY OR sfrYCtrVal (Value) */
        /* cp_sfrZ OR sfrZCtrVal (Value) */
        /* cp_maskX OR maskXCtrVal (Value) */
        /* cp_maskY OR maskYCtrVal (Value) */
        /* cp_maskZ OR maskZCtrVal (Value) */
        /* cp_idxOffsetX OR idxOffsetXCtrVal (Value) */
        /* cp_idxOffsetY OR idxOffsetYCtrVal (Value) */
        /* cp_idxOffsetZ OR idxOffsetZCtrVal (Value) */
        /* cp_sizeX OR sizeXCtrVal (Value) */
        /* cp_sizeY OR sizeYCtrVal (Value) */
        /* cp_sizeXY OR sizeXYCtrVal (Value) */
        /* cp_gainX OR gainXCtrVal (Value) */
        /* cp_gainY OR gainYCtrVal (Value) */
        /* cp_gainZ OR gainZCtrVal (Value) */
        /* cp_gainXsfr OR gainXsfrCtrVal (Value) */
        /* cp_gainYsfr OR gainYsfrCtrVal (Value) */
        /* cp_gainZsfr OR gainZsfrCtrVal (Value) */
        /* cp_offsetX OR offsetXCtrVal (Value) */
        /* cp_offsetY OR offsetYCtrVal (Value) */
        /* cp_offsetZ OR offsetZCtrVal (Value) */
        /* cp_minX OR minXCtrVal (Value) */
        /* cp_maxX OR maxXCtrVal (Value) */
        /* cp_minY OR minYCtrVal (Value) */
        /* cp_maxY OR maxYCtrVal (Value) */
        /* cp_minZ OR minZCtrVal (Value) */
        /* cp_maxZ OR maxZCtrVal (Value) */

        /* USERCODE-BEGIN:ConvImplementationToMask */
        /* TODO Add Implementation- to Mask conversion */
        /* USERCODE-END:ConvImplementationToMask */

        /* Mask parameter values */
        /* mp_TableData OR TableDataMaskVal (Number) */
        /* mp_DimX OR DimXMaskVal (String) */
        /* mp_x_min OR x_minMaskVal (Number) */
        /* mp_x_max OR x_maxMaskVal (Number) */
        /* mp_DimY OR DimYMaskVal (String) */
        /* mp_y_max OR y_maxMaskVal (Number) */
        /* mp_y_min OR y_minMaskVal (Number) */
        /* mp_DimZ OR DimZMaskVal (String) */
        /* mp_z_min OR z_minMaskVal (Number) */
        /* mp_z_max OR z_maxMaskVal (Number) */

        if (Double.isNaN(mp_TableData)) {
            this.getMaskParameter("TableData").setValue(TableDataMaskData.toFullString());
        } else {
            this.getMaskParameter("TableData").setValue(new TNumeric(mp_TableData).toFullString());
        }
        if (mp_DimX == null) {
            this.getMaskParameter("DimX").setValue(DimXMaskData.getString());
        } else {
            this.getMaskParameter("DimX").setValue(mp_DimX);
        }
        if (Double.isNaN(mp_x_min)) {
            this.getMaskParameter("x_min").setValue(x_minMaskData.toFullString());
        } else {
            this.getMaskParameter("x_min").setValue(new TNumeric(mp_x_min).toFullString());
        }
        if (Double.isNaN(mp_x_max)) {
            this.getMaskParameter("x_max").setValue(x_maxMaskData.toFullString());
        } else {
            this.getMaskParameter("x_max").setValue(new TNumeric(mp_x_max).toFullString());
        }
        if (mp_DimY == null) {
            this.getMaskParameter("DimY").setValue(DimYMaskData.getString());
        } else {
            this.getMaskParameter("DimY").setValue(mp_DimY);
        }
        if (Double.isNaN(mp_y_max)) {
            this.getMaskParameter("y_max").setValue(y_maxMaskData.toFullString());
        } else {
            this.getMaskParameter("y_max").setValue(new TNumeric(mp_y_max).toFullString());
        }
        if (Double.isNaN(mp_y_min)) {
            this.getMaskParameter("y_min").setValue(y_minMaskData.toFullString());
        } else {
            this.getMaskParameter("y_min").setValue(new TNumeric(mp_y_min).toFullString());
        }
        if (mp_DimZ == null) {
            this.getMaskParameter("DimZ").setValue(DimZMaskData.getString());
        } else {
            this.getMaskParameter("DimZ").setValue(mp_DimZ);
        }
        if (Double.isNaN(mp_z_min)) {
            this.getMaskParameter("z_min").setValue(z_minMaskData.toFullString());
        } else {
            this.getMaskParameter("z_min").setValue(new TNumeric(mp_z_min).toFullString());
        }
        if (Double.isNaN(mp_z_max)) {
            this.getMaskParameter("z_max").setValue(z_maxMaskData.toFullString());
        } else {
            this.getMaskParameter("z_max").setValue(new TNumeric(mp_z_max).toFullString());
        }
    }
}
